var EnvironmentChecked                         = false;
var ReminderExists                             = false;
var PreispiratenExists                         = false;

const C_CMDSWITCH_CHECK_REMINDER_EXISTS        = '-rem';
const C_CMDSWITCH_CHECK_PREISPIRATEN_EXISTS    = '-pp2';

const C_CMDSWITCH_PREISPIRATEN_START           = '-pp2start';
const C_CMDSWITCH_PREISPIRATEN_SEARCH          = '-pp2search';

const C_CMDSWITCH_REMINDER_START               = '-remstart';
const C_CMDSWITCH_REMINDER_ADDAUCTION          = '-remaddauction';
const C_CMDSWITCH_REMINDER_BIDDING             = '-rembidding';
const C_CMDSWITCH_REMINDER_AUTOBIDDING         = '-remautobidding';

const C_EXITCODE_CHECK_REMINDER_EXISTS         = 1;
const C_EXITCODE_CHECK_PREISPIRATEN_EXISTS     = 2;

// ------------------------------------------------------------------------------------
function FindFile(path, directoryService) {
  var ExeFile = directoryService.get(path,Components.interfaces.nsILocalFile); 

  // auf das Programm gehen 
  ExeFile.append("extensions"); 
  ExeFile.append("{411F2F11-830F-4AB5-B7F0-FBC77B870B5A}"); 
  ExeFile.append("chrome"); 
  ExeFile.append("buyertools.exe"); 
  
  return ExeFile;
};

function RunExternalProcess(switches) {   
  var directoryService=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties); 

  // Erweiterungen in Profile-Verzeichnis des Users
  var ExeFile = FindFile("ProfD", directoryService);
  
  // Globale Erweiterungen
  if (!ExeFile.exists()) {
    ExeFile = FindFile("CurProcD", directoryService);
  };
  
  // initialisieren
  var ExeProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess); 
  ExeProcess.init(ExeFile); 

  // und los
  ExeProcess.run(true,[switches],1);

  return ExeProcess.exitValue; 
};

// ------------------------------------------------------------------------------------

function CouldBeEbayURL() {
  var url = window._content.document.URL.toLowerCase();
  if ((url.indexOf("ebay.") > -1) && 
      ((url.indexOf("item=") > -1) ||
      (url.indexOf("qqitemz") > -1))) 
  {
    return true;
  } else {
    return false;
  };
};

// ------------------------------------------------------------------------------------

function PreispiratenStart() {
  RunExternalProcess(C_CMDSWITCH_PREISPIRATEN_START);
};

function PreispiratenSuche() {
  var s = window._content.document.getSelection();
  if (s == "") {
    return 0;  
  };  

  RunExternalProcess(C_CMDSWITCH_PREISPIRATEN_SEARCH+" "+s);
};

// ------------------------------------------------------------------------------------

function ReminderStart() {
  RunExternalProcess(C_CMDSWITCH_REMINDER_START);
};

function ReminderAddAuction() {
  RunExternalProcess(C_CMDSWITCH_REMINDER_ADDAUCTION+" "+window._content.document.URL);
};

function ReminderBidding() {
  RunExternalProcess(C_CMDSWITCH_REMINDER_BIDDING+" "+window._content.document.URL);
};

function ReminderAutoBidding() {
  RunExternalProcess(C_CMDSWITCH_REMINDER_AUTOBIDDING+" "+window._content.document.URL);
};

// ------------------------------------------------------------------------------------

function CheckForReminderAndPreispiraten() {
  var r = RunExternalProcess(C_CMDSWITCH_CHECK_REMINDER_EXISTS+" "+C_CMDSWITCH_CHECK_PREISPIRATEN_EXISTS);

  if ((r && C_EXITCODE_CHECK_REMINDER_EXISTS)==C_EXITCODE_CHECK_REMINDER_EXISTS) {
    ReminderExists  = true;
  } else {
    ReminderExists  = false;
  };

  if ((r && C_EXITCODE_CHECK_PREISPIRATEN_EXISTS)==C_EXITCODE_CHECK_PREISPIRATEN_EXISTS) {
    PreispiratenExists  = true;
  } else {
    PreispiratenExists  = false;
  };
};

function OnPopupBuyertoolsMenu() {
  // nur wenn wir das noch nicht berprft haben checken wir, ob Preispiraten und/oder Reminder installiert sind
  if (EnvironmentChecked==false) {
    EnvironmentChecked = true;
    CheckForReminderAndPreispiraten();
  };

  // Produktsuche bei eBay nur erlauben, wenn was markiert wurde
  if (window._content.document.getSelection()=="") {
    document.getElementById("buyertoolsEbayProductSearch").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsEbayProductSearch").setAttribute("disabled","false");
  };

  // Produktsuche ber Preispiraten
  if ((PreispiratenExists==false) || (window._content.document.getSelection()=="")) {
    document.getElementById("buyertoolsPreispiratenProductSearch").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsPreispiratenProductSearch").setAttribute("disabled","false");
  };

  // Preispiraten anzeigen
  if (PreispiratenExists==false)  {
    document.getElementById("buyertoolsPreispiratenDisplay").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsPreispiratenDisplay").setAttribute("disabled","false");
  };

  // Reminder anzeigen
  if (ReminderExists==false)  {
    document.getElementById("buyertoolsReminderDisplay").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsReminderDisplay").setAttribute("disabled","false");
  };

  // Reminder Auktion hinzufgen
  if ((ReminderExists==false) || (CouldBeEbayURL()==false)) {
    document.getElementById("buyertoolsReminderAddAuction").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsReminderAddAuction").setAttribute("disabled","false");
  };

  // Reminder Autobieten
  if ((ReminderExists==false) || (CouldBeEbayURL()==false)) {
    document.getElementById("buyertoolsReminderAutobidding").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsReminderAutobidding").setAttribute("disabled","false");
  };

  // Reminder normales Bieten
  if ((ReminderExists==false) || (CouldBeEbayURL()==false)) {
    document.getElementById("buyertoolsReminderBidding").setAttribute("disabled","true");
  } else {
    document.getElementById("buyertoolsReminderBidding").setAttribute("disabled","false");
  };

  return true;
};